<?php

namespace Treewec\Admin;

/**
 * Test class for FileEditForm.
 * Generated by PHPUnit on 2012-06-25 at 13:15:24.
 * @group admin_fileform
 */
class FileEditFormTest extends \PHPUnit_Framework_TestCase {

    private $formObject;

    protected function setUp() {
        $_POST['submit'] = 'submit';
    }

    public function testSuccessFileEdit() {
        $filenames = array('test', 'existing-žeš');
        foreach ($filenames as $name) {
            $filePath = $this->getPath($name, true);
            $this->assertContentChange($filePath, file_get_contents($filePath));
        }
    }

    public function testSuccessFolderEdit() {
        $filenames = array('test', 'existing-žeš');
        foreach ($filenames as $name) {
            $folderPath = $this->getPath($name, false);
            $indexPath = $folderPath . TREEWEC_NAME_OF_INDEX_FILE . TREEWEC_DEFAULT_FILE_EXTENSION;
            $existsIndexInFolder = file_exists($indexPath);
            $currentContent = $existsIndexInFolder ? file_get_contents($indexPath) : '';
            $this->assertContentChange($folderPath, $currentContent);            
            if (!$existsIndexInFolder) {
                unlink($indexPath);
            }
        }
    }

    public function testInvalidContent() {
        $this->setFormAndProcess(TEMP_FILEDIR . 'test.php', array());
        parent::assertFalse($this->formObject->isValid());
    }

    public function testInvalidPath() {
        $this->setFormAndProcess(null, 'newContent');
        parent::assertFalse($this->formObject->isValid());
    }

    private function assertContentChange($filePath, $currentContent) {
        // same content            
        $this->setFormAndProcess($filePath, $currentContent);
        parent::assertFalse($this->formObject->isValid());
        // success
        $this->setFormAndProcess($filePath, $currentContent . 'edit');
        parent::assertTrue($this->formObject->isValid());
        // success
        $this->setFormAndProcess($filePath, $currentContent);
        parent::assertTrue($this->formObject->isValid());
    }

    private function setFormAndProcess($filePath, $newContent) {
        $this->formObject = new FileEditForm('submit', true);
        $this->formObject->setSuccessAction(FormSuccessAction::NOTHING);
        $this->formObject->setFilePath($filePath);
        $_POST['editContent'] = $newContent;
        $this->formObject->process();
    }

    private function getPath($name, $isFile) {
        $extension = $isFile ? '.php' : '/';
        return TEMP_FILEDIR . \Treewec\FileSystem\Path::toFileSystem($name) . $extension;
    }

}

?>